/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef _NEST_ADVERTISER_H
#define _NEST_ADVERTISER_H

#include "nest_common.h"
#include "nest_protocol.h"
#include "nest_protocol_manager.h"
#include "nest_storage_manager.h"
#include "nest_io_manager.h"
#include "nest_collection_manager.h"

#define AD_NAME "NestAd"

class
nestAd {

  public:
    nestAd( nestProtocol *src, int len );

    ~nestAd( );

    char *toString( );

    int length( );

  private:
    char *myad;
    int  mylen;
};

class
nestAdvertiser
{

  public:
	nestAdvertiser( void );
	~nestAdvertiser( void );

    static int init( );

    static NestReplyStatus writeAd( nestProtocol *dest );

    static nestAd *readAd( nestProtocol *src, int len );
    
  private:

};

extern nestAdvertiser	*advertiser;

#endif
