/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef NEST_CLIENT_UTIL_H
#define NEST_CLIENT_UTIL_H

#include "nest_shared.h"
#include "nest_error.h"

void
NestFormatAccessString(
	nest_access_rights_t	access,
	char					*access_string
	);

NestReplyStatus
NestParseAccessString(
	nest_access_rights_t	*access,
	const char				*string
	);

const char *
NestFormatLotSize(
	nestLotSize				size,
	char					*buf,
	int						bufsize,
	bool					rawvalue = false
	);

NestReplyStatus
NestParseLotSize(
	const char				*arg,
	nestLotSize				*size
	);

const char *
NestFormatLotTime(
	int						seconds,
	char					*buf,
	int						bufsize,
	bool					rawvalue = false
	);

NestReplyStatus
NestParseLotTime(
	const char				*arg,
	int						*seconds
	);

const char *
NestFormatFileSize(
	nestFileSize			size,
	char					*buf,
	int						bufsize,
	bool					raw = false
	);

#endif
