/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef _NEST_DEVICE_H_
#define _NEST_DEVICE_H_

#include "nest_shared.h"

#ifndef NEST_NAMELEN
#define NEST_NAMELEN            40
#endif

class NestDevice
{
  public:
	NestDevice( const char *dev );
	~NestDevice( void );

	void setCapacity( nestLotSize cap )
		{ this->capacity = cap; };
	void setUserUsage( nestLotSize usage )
		{ this->user_usage = usage; };
	void setGroupUsage( nestLotSize usage )
		{ this->group_usage = usage; };
	void setBlockSize( long size )
		{ this->block_size = size; };

	const char *getDevName( void ) const
		{ return dev_name; };
	nestLotSize getCapacity( void ) const
		{ return capacity; };
	nestLotSize getUserUsage( void ) const
		{ return user_usage; };
	nestLotSize getGroupUsage( void ) const
		{ return group_usage; };
	long getBlockSize( void ) const
		{ return block_size; };
	nestLotSize getAvailableUser( void ) const
		{ return ( capacity - user_usage ); };
	nestLotSize getAvailableGroup( void ) const
		{ return ( capacity - group_usage ); };

  private:
    char            *dev_name;
    nestLotSize     capacity;
    nestLotSize     user_usage;
    nestLotSize     group_usage;
	long			block_size;
};

#endif
