/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#include <stdlib.h>
#include <string.h>

#include "nest_dsi_config.h"
#include "nest_speak.h"
#include "nest_shared.h"

nestDsiConfig::nestDsiConfig( void )
{
	char	*tmp;

	// Activation code: Figure out where to log to
	log_file = NULL;
	tmp = getenv( "NEST_DSI_LOG_FILE" );
	if( tmp ) {
		log_file = strdup( tmp );
	}

	log_flags = NULL;
	tmp = getenv( "NEST_DSI_LOG_FLAGS" );
	if( tmp ) {
		log_flags = strdup( tmp );
	}

	log_max_size = 64 * 1024;
	tmp = getenv( "NEST_DSI_LOG_MAX" );
	if( tmp && isdigit( *tmp ) ) {
		long long	tmpsize = 64 * 1024;
		NestParseSizeString( tmp, &tmpsize, 'k' );
		log_max_size = tmpsize;		// We shouldn't need long long for logs!
	}

	// Server host
	tmp = getenv( "NEST_DSI_SERVER" );
	char	hostname[128];
	if ( NULL == tmp ) {
		memset( hostname, 0, sizeof( hostname ) );
		gethostname( hostname, sizeof( hostname ) );
		tmp = hostname;
	}
	server_name = strdup( tmp );

	// Server port
	server_port = NEST_SERVER_PORT;
	tmp = getenv( "NEST_DSI_PORT" );
	if ( tmp && isdigit( *tmp ) ) {
		server_port = atoi( tmp );
	}
}

nestDsiConfig::~nestDsiConfig( void )
{
	if ( log_file ) {
		free( (void*) log_file );
	}
	if ( server_name ) {
		free( (void*) server_name );
	}
}
