/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef NEST_DSI_SESSION_H
#define NEST_DSI_SESSION_H

#include "nest_speak.h"
extern "C" {
#include "globus_gridftp_server.h"
}

class nestDsiSession
{
public:
	nestDsiSession( const char *server,
					int port,
					const globus_gfs_session_info_t *session_info );
	nestDsiSession( nestDsiSession * );
	~nestDsiSession( void );
	int connect( globus_gfs_operation_t gfsOp );
	int disconnect( void );

	bool isConnected( void ) { return connected; };
	NestConnection getConnection( void ) { return connection; };
	NestReplyStatus getStatus( void ) { return status; };
	const char *getErrName( void ) { return "connect"; };
	const char *getUsername( void ) { return session_info.username; };

private:
	globus_gfs_session_info_t	session_info;
	NestConnection	connection;
	NestReplyStatus	status;
	bool			connected;
	const char		*server;
	int				port;

	int copy_session_info( const globus_gfs_session_info_t *info );
};


#endif
