/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef NEST_DSI_STAT_H
#define NEST_DSI_STAT_H

#include "nest_speak.h"
#include "nest_dsi_transfer.h"
extern "C" {
#include "globus_gridftp_server.h"
}

class nestDsiStat
{
  public:
	nestDsiStat( nestDsiSession *parent_session );
	~nestDsiStat( void );

	// Methods to do the actual transfer & related things
	int doStat( globus_gfs_operation_t	op,
				globus_gfs_stat_info_t	*stat_info );
	void storeFileInfo( const NestFileInfo *finfo );
	void storeDir( const char *name );

  private:
	nestDsiSession		*session;
	nestDsiSession		*parent_session;

	NestFileInfo		*list, *end;
	int					count;

	void CopyFileInfo( const NestFileInfo *, globus_gfs_stat_t * );
	void FreeStatbuf( globus_gfs_stat_t * );
};


#endif
