/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef _NEST_GLOBUS_H
#define _NEST_GLOBUS_H

extern "C" {
#include "globus_common.h"
}
extern "C" {
    #include "globus_ftp_control.h"
}
extern "C" {
    #include "globus_ftp_client.h"
}
extern "C" {
    #include "globus_fifo.h"
}
extern "C" {
    #include "globus_gss_assist.h"
}

#include "nest_shared.h"

#define AUTH_SUBJECT_MAX 1024
#define AUTH_TYPE_MAX 1024
#define AUTH_LINE_MAX 80

NestReplyStatus inquireGlobusCredential(    gss_name_t *name, 
                                            OM_uint32 *lifetime,
                                            gss_cred_id_t *credential_handle) ;

NestReplyStatus acquireGlobusCredential( gss_cred_id_t *cred_handle,
        gss_cred_usage_t credential_usage );

NestReplyStatus auth_globus_accept(
	int socket,
	char **subject,
	char **globus_username );

int auth_globus_get_cred(
	gss_cred_id_t *cred );
void auth_globus_release_cred(
	gss_cred_id_t cred );
int auth_globus_assert(
	int sd,
	const char *server,
	gss_cred_id_t cred,
	int cred_ok );

#endif
