/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef     __NEST_LOT_H__
#define     __NEST_LOT_H__

#include "nest_storage_common.h"
#include "nest_user.h"

#define G_LOT 0
#define BE_LOT 1

class NestLotInternal {
  public:
	NestLotInternal( void );
	~NestLotInternal( void );
	void clean( void );

    char                    lot_handle[NEST_NAMELEN];
    char                    parent_lot_handle[NEST_NAMELEN];
	nestUserOrGroup			*owner;
    char                    lot_users[NEST_MESSAGESIZE];
    char                    dev[NEST_NAMELEN];
    nestLotSize             total_size;
    nestLotSize             size;
    nestLotSize             used;
    int                     start_time;
    int                     duration;
    int                     time_left;
    int                     cost;
    int                     lot_type;
};

class NestLotListInternal {
  public:
	NestLotListInternal( void );
	~NestLotListInternal( void );

    NestLotInternal			stat;
    NestLotListInternal		*next;
};

#endif
