/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/
#include "nest_pread.h"

/* A number of platforms fail to prototype these functions */
//extern ssize_t pread( int fd, void *buf, size_t count, off_t offset );
//extern ssize_t pwrite( int fd, const void *buf, size_t count, off_t offset );

ssize_t 
NestPwrite( int fd, const void *buf, size_t count, off_t offset ) {
    ssize_t w = pwrite( fd, buf, count, offset );
    if ( w < 0 ) nest_perror( "pwrite" );
    return w;

}

ssize_t 
NestPread( int fd, void *buf, size_t count, off_t offset ) {
    ssize_t r = pread( fd, buf, count, offset );
    if ( r < 0 ) nest_warn( __FILE__, __FUNCTION__, "pread fd:%d, off:%ld, size:%ld %s", fd, offset, count, strerror(errno) );
    return r;
}

