/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef _NEST_PROTOCOL_ADVERTISE_H
#define _NEST_PROTOCOL_ADVERTISE_H

#include "nest_common.h"
#include "nest_protocol.h"

class nestProtocolAdvertise : public nestProtocol
{
public:


    nestProtocolAdvertise( );

    virtual ~nestProtocolAdvertise();

    virtual ssize_t Receive( char *buffer, ssize_t n );

    virtual ssize_t Send( const char *buffer, ssize_t n );

    virtual int getType( ) { return ADVERTISE_PROTOCOL; }

    virtual bool hasSocket() { return true; }

    virtual bool sendErrorMessage(  const char* filename, const char* func_name, int error );
    
    virtual int getSocket() { return socket; }

    virtual NestReplyStatus receive_state( int pipe );

    virtual NestReplyStatus send_state( int pipe );

    virtual bool sendAck();

    virtual bool sendFilesize( nestFileSize filesize );

    virtual nestRequest *receiveRequest( void );

    bool connect( const char *host, int port );
    
    virtual bool sendTransferInfo( class nestRequest *req );

    virtual nestProtocol *clone();

	const char *getName( void ) { return "Advertiser"; };

private:
    void init( );
    
    int     socket;
    struct  sockaddr_in address;
};

#endif
