/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef _NEST_PROTOCOL_HTTP_H
#define _NEST_PROTOCOL_HTTP_H

#include "nest_common.h"
#include "nest_protocol.h"
#include "nest_storage_manager.h"

#define HTTPMESSAGESIZE 4096

class nestProtocolHttp : public nestProtocol {
public:
    static int listen( int port );

    static nestProtocol* accept( int socket, sockaddr_in *address );
    
    static NestReplyStatus initiateThirdParty( nestClient *client,
            nestProtocol **connection );
    
    nestProtocolHttp( int socket );
    
    virtual ~nestProtocolHttp();

    virtual bool sendFinalAck( int transferType );
    
    virtual bool persistent();
    
    virtual bool sendAck(  );

    virtual bool sendAd( nestAd *ad );
    
    virtual bool sendTransferInfo( nestRequest* request );
    
    virtual bool sendErrorMessage(  const char* filename,
									const char* func_name, int error );
    
    virtual bool sendFilesize( nestFileSize size);
    
    virtual nestRequest* receiveRequest( void );

    virtual ssize_t Receive( char *buffer, ssize_t n );

    virtual ssize_t Send( const char *buffer, ssize_t n );
    
    virtual int getType( ) { return HTTP_PROTOCOL; }

    virtual bool hasSocket();

    virtual nestProtocol *clone();

    int getSocket();
    
    virtual bool endThirdPartyTransfer( int ); 

	const char *getName( void ) { return "HTTP"; };

private:
    int socket;
    bool keep_alive;
    bool still_alive;
    bool already_closed;
    char message[HTTPMESSAGESIZE];

    static bool fullMessage( char *message ); 
    static NestReplyStatus HttpStatusToNestStatus( int status ); 

    nestRequest* closeConnectionRequest();
    char *convertFilename( char *req, char *filename, int BUFSIZE );
    
    bool closeNonpersistent();

    char *errorstring( int errorcode );
    
    bool sendMessage(  const void *vptr, int errorcode );

    bool sendHeader( int len, int errorcode );
};

#endif
