/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef _NEST_PROTOCOL_NEST_H
#define _NEST_PROTOCOL_NEST_H

#include "nest_common.h"
#include "nest_protocol.h"
#include "nest_speak.i.h"
#include "nest_client.h"


class nestProtocolNest : public nestProtocol {
public:
    static int listen( int port );

    static nestProtocol* accept( int socket, sockaddr_in *address );

    static NestReplyStatus initiateThirdParty( nestClient *client,
            nestProtocol **connection );

    nestProtocolNest( int socket );

    virtual ~nestProtocolNest();

    virtual NestReplyStatus gssAccept( char **username,
									   char **globus_username );
    
    virtual nestRequest* receiveRequest( void );

    virtual bool endThirdPartyTransfer( int type );

    virtual bool sendVersion( const char * );
    
    virtual bool sendPwd( const char *pwd );

    virtual bool sendDirectoryList( NestFileInfo *list );

    virtual bool sendAd( nestAd *ad );

    virtual bool sendDiskspace( nestFileSize avail, nestFileSize total  );

    virtual bool sendErrorMessage(  const char* filename,
									const char* func_name,
									int error );

    virtual bool sendAck( );

    virtual bool sendFinalAck( int transferType );

    virtual bool sendTransferInfo( nestRequest *req );

    virtual bool sendTimestamp( );

    virtual bool sendFilesize( nestFileSize size);

    virtual NestReplyStatus sendFileinfo( const NestFileInfo *info );

    virtual bool sendPhysicalName( const char *name );

    virtual bool sendAcl( const char *user,
                          int is_user,
                          nest_access_rights_t access );

    virtual bool sendAcl( const NestACL *Acl);

    virtual bool sendNestLot( NestLotInternal *rstat );

    virtual bool sendLotHandle( NestLotHandle *handle );

    virtual bool sendProxyList( list <char *> *proxys );
    
    virtual ssize_t Receive( char *buffer, ssize_t n );

    virtual ssize_t Send( const char *buffer, ssize_t n );

    virtual int getType( ) { return NEST_PROTOCOL; }

    virtual bool hasSocket() { return true; }

    virtual nestProtocol *clone();

    int getSocket() { return socket; }

	const char *getName( void ) { return "Chirp"; };

protected:
    //static sockaddr_in cliaddr;
    //static unsigned addr_sz;

    bool sendMessage( const void *vptr );
    nestRequest* parseRequest( char *msg );
    bool sendTransferInfo( int csd, char *file, int type, long len );
    int socket;
    char msg[NEST_MESSAGESIZE];
    int  msgoffset;

};

#endif
