/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/
#ifndef __NEST_PROXY_H_
#define __NEST_PROXY_H_

#include "nest_common.h"
#include "nest_client_pool.h"
#include "dynamic-lard.h"
#include "nest_protocol_proxy.h"
#include "nest_proxy_fetch.h"
#include "nest_user.h"

#include "nest_proxy_client_cache.h"

bool serverIsProxy();

int initProxy( nestClientPool *clientPool );

NestReplyStatus proxyRegisterProxyClient( nestClient *client, char *proxy );

NestReplyStatus addNewClientToProxy( nestClient *client );

NestReplyStatus removeClientFromProxy( nestClient *client );

NestReplyStatus connectMonitor( char *monitor );

NestReplyStatus FlushProxyCache( nestClient *client );

NestReplyStatus ReceiveProxyIndex( nestClient *client );

int	getProxyCount();

NestReplyStatus openHomeConnection( nestClient ** );

NestReplyStatus proxyTranslateRequest( nestClient *client );

NestReplyStatus addProxyTransfer( nestClient *client );

bool taskWasProxyTask( nestClient *client, NestReplyStatus status );

NestReplyStatus flushDirtyWrites( nestClient *client );

void writeProxyAd( nestProtocol *ad );

void proxyHelp();

void proxyMaintenance();

NestReplyStatus startProxyFetch( nestProxyFetch *fetch );

NestReplyStatus  proxyFilelength(  nestFileSize *filesize,  
                                   const char *filename,
                                   const nestUser *user,
                                   const char *cwd );

NestReplyStatus  proxyFileinfo(  NestFileInfo *info,
								 const char *filename,
								 const nestUser *user,
								 const char *cwd );

#endif
