/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef NEST_PWENT_H
#define NEST_PWENT_H

#include <sys/types.h>
#include "nest_common.h"

class nestPwent
{
public:
	nestPwent( void );
	~nestPwent( void );

	// Locate a passwd entry
	int findent( user_id_t uid, const char *pwfile = NULL );
	int findent( const char *user, const char *pwfile = NULL );

	// Access the passwd entry
	bool isvalid( void ) const { return valid; };
	const struct passwd *getent( void ) const;
	const char *getent_name( void ) const;
	const char *getent_passwd( void ) const;
	uid_t getent_uid( void ) const;
	gid_t getent_gid( void ) const;
	const char *getent_gecos( void ) const;
	const char *getent_dir( void ) const;
	const char *getent_shell( void ) const;

private:
	struct passwd	pwent;
	bool			valid;

	void clear( void );
	int copyent( struct passwd *ent );
};

#endif
