/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef     _QUOTA_INSTANCE_H_
#define     _QUOTA_INSTANCE_H_

#include "nest_common.h"
#include "nest_device.h"

class   QuotaInstance {
  private:

  public:

	virtual NestReplyStatus add_entity(const nestUserOrGroup *name,
									   const char *dev,
									   nestLotSize size,
									   int inode_count) = 0;

	virtual NestReplyStatus delete_entity(const nestUserOrGroup *name,
										  const char *dev) = 0;

	virtual NestReplyStatus update_entity(const nestUserOrGroup *name,
										  const char *dev,
										  nestLotSize new_size,
										  int new_inode_count) = 0;

	virtual NestReplyStatus view_entity_usage(const nestUserOrGroup *name,
											  const NestDevice *disk,
											  nestLotSize *size,
											  int *inode_count) = 0;

	virtual NestReplyStatus initialize(const NestDevice *dev) = 0;
};

#endif
