/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef NEST_SERVER_H
#define NEST_SERVER_H

#include "nest_error.h"
#include "nest_client.h"
#include "nest_client_pool.h"

class nestServer
{
  public:
	nestServer( void );
	~nestServer( void );
	int init( int argc, const char *argv[] );
	int getMaxfd( void );
	NestReplyStatus RegularMaintenance( void );
	struct timeval *getNextTimeout( void );
	void setMaintenanceInterval( int value );
	NestReplyStatus WriteAd( void );
	nestClientPool *getClients( void );
	NestReplyStatus NewClient( nestClient *newclient );

  private:

	NestReplyStatus advertise( void );

	    // timer to do regular maintenance
	struct timeval last_maintenance;
	int maintenance_interval;

    	// collection of currently connected clients
	nestClientPool *clients;


};

extern nestServer *nest_server;

#endif
