/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef NEST_SPEAK_I_H
#define NEST_SPEAK_I_H

/*
file class is for nest_speak (nest protocol specific functions) which do
not need to be accessible to the client, but need to be accessible by
the protocol manager
*/

#include <stdio.h>
#include "dynamic-lard.h"
#include "nest_shared.h"
#include "nest_globus.h"

NestReplyStatus
myNestOpenConnection( NestConnection &con,
					  const char *nestlocation,
					  bool anon,
					  bool user_user_auth,
					  int port,
					  const char *user = NULL,
					  gss_cred_id_t cred = GSS_C_NO_CREDENTIAL );

bool SendNestMessage( NestConnection con, const void *vptr );
NestReplyStatus ReceiveNestMessage( NestConnection con, void *vptr );
NestReplyStatus ReceiveNestPartialMessage( NestConnection, void *, int, int * );

NestReplyStatus NestSendIndex( NestConnection, DynamicLard *index );
NestReplyStatus NestReceiveIndex( NestConnection, DynamicLard *,
                                  StringToServerFunc *,
                                  void *args );

bool SendSimpleRequest( NestConnection con, int request );
bool PrintFromSocket( NestConnection con );
bool PrintFromSocket( NestConnection con, FILE *out );

NestReplyStatus ReceiveNestAck( NestConnection con );
NestReplyStatus ReceiveNestAck( NestConnection con, void *vptr );

NestReplyStatus RequestWriteFile( const char *file,
								  nestFileSize offset,
								  nestFileSize length,
								  NestConnection );

NestReplyStatus RequestReadFile( const char *file,
								 nestFileSize offset,
								 nestFileSize &length,
								 NestConnection );

#endif
