/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef _NEST_STORAGE_COMMON_H_

#define _NEST_STORAGE_COMMON_H_

#include <sys/types.h>
#include <sys/time.h>
#include <sys/param.h>

#include "nest_shared.h"
#include "nest_arch_specific.h"

#define IS_USER             1
#define IS_GROUP            0

#define SECONDS(x)          (x)
#define MINUTES(x)          ((x) * SECONDS(60))
#define HOURS(x)            ((x) * MINUTES(60))
#define DAYS(x)             ((x) * HOURS(24))
#define WEEKS(x)            ((x) * DAYS(7))
#define MONTHS(x)           ((x) * DAYS(30))
#define YEARS(x)            ((x) * DAYS(365))

#define NEST_BLK_SIZE        1024

#define NUM_BLKS(x)         ((int)(MB_BLKS(x) + 0.999999))
#define SIZE_IN_MB(x)       ( (double) (((double) (x)) / 1024) )

#define KB_BLKS(x)          (x)
#define MB_BLKS(x)          (KB_BLKS(x) * 1024)
#define GB_BLKS(x)          (MB_BLKS(x) * 1024)

#define DEFAULT_LOT_DURATION    (DAYS(1))
#define INFINITE_LOT_DURATION   (YEARS(50))		// 50 years

//  Ratio between data to number of inodes!
#define DATA_KB_PER_INODE   8    //    in KB, of course

#define NEST_EVERYBODY		"nest_everybody"
#define NEST_NOBODY			"nest_nobody"

#define NEST_NO_GROUP		"no_nest_group"



typedef long unsigned int    user_id_t;

#define        MAX_USR_ENTRIES    100

struct group_ent {
    char    grp_name[NEST_NAMELEN];
    char    grp_passwd[NEST_NAMELEN];
    gid_t    grp_gid;
    char    grp_entries[MAX_USR_ENTRIES][NEST_NAMELEN];
};

typedef struct group_ent group_ent;

#endif
